// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.administration.user;

import fr.ifremer.adagio.core.dao.referential.Status;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Date;

/**
 * Transfert des droits entre un service et un autre service.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class DepartmentPrivilegeTransfert
    implements Serializable, Comparable<DepartmentPrivilegeTransfert>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 8128614373079839362L;

    private DepartmentPrivilegeTransfertPK departmentPrivilegeTransfertPk;

    /**
     * Get the composite primary key identifier class
     * @return departmentPrivilegeTransfertPk
     */
    public DepartmentPrivilegeTransfertPK getDepartmentPrivilegeTransfertPk()
    {
        return this.departmentPrivilegeTransfertPk;
    }

    /**
     * Set the composite primary key identifier class
     * @param departmentPrivilegeTransfertPkIn
     */
    public void setDepartmentPrivilegeTransfertPk(DepartmentPrivilegeTransfertPK departmentPrivilegeTransfertPkIn) {
        this.departmentPrivilegeTransfertPk = departmentPrivilegeTransfertPkIn;
    }

    // Generate 2 attributes
    private Date transfertDate;

    /**
     * Date du transfert des droits entre service
     * @return this.transfertDate Date
     */
    public Date getTransfertDate()
    {
        return this.transfertDate;
    }

    /**
     * Date du transfert des droits entre service
     * @param transfertDateIn Date
     */
    public void setTransfertDate(Date transfertDateIn)
    {
        this.transfertDate = transfertDateIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    // Generate 3 associations
    private Department fromDepartment;

    /**
     * Identifiant interne du service possédant les droits à l''origine
     * @return this.fromDepartment Department
     */
    public Department getFromDepartment()
    {
        return this.fromDepartment;
    }

    /**
     * Identifiant interne du service possédant les droits à l''origine
     * @param fromDepartmentIn Department
     */
    public void setFromDepartment(Department fromDepartmentIn)
    {
        this.fromDepartment = fromDepartmentIn;
    }

    private Status status;

    /**
     * Code de l''état de l''objet (actif ou inactif)
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Code de l''état de l''objet (actif ou inactif)
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    private Department toDepartment;

    /**
     * Identifiant interne du service vers qui les droits sont transférés
     * @return this.toDepartment Department
     */
    public Department getToDepartment()
    {
        return this.toDepartment;
    }

    /**
     * Identifiant interne du service vers qui les droits sont transférés
     * @param toDepartmentIn Department
     */
    public void setToDepartment(Department toDepartmentIn)
    {
        this.toDepartment = toDepartmentIn;
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    @Override
    public boolean equals(Object object)
    {
        return super.equals(object);
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only take the identifiers of this entity into account when calculating the hash code.
     */
    @Override
    public int hashCode()
    {
        return super.hashCode();
    }

    /**
     * Constructs new instances of {@link DepartmentPrivilegeTransfert}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link DepartmentPrivilegeTransfert}.
         * @return new DepartmentPrivilegeTransfertImpl()
         */
        public static DepartmentPrivilegeTransfert newInstance()
        {
            return new DepartmentPrivilegeTransfertImpl();
        }

        /**
         * Constructs a new instance of {@link DepartmentPrivilegeTransfert}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param transfertDate Date
         * @param fromDepartment Department
         * @param status Status
         * @param toDepartment Department
         * @return newInstance
         */
        public static DepartmentPrivilegeTransfert newInstance(Date transfertDate, Department fromDepartment, Status status, Department toDepartment)
        {
            final DepartmentPrivilegeTransfert entity = new DepartmentPrivilegeTransfertImpl();
            entity.setTransfertDate(transfertDate);
            entity.setFromDepartment(fromDepartment);
            entity.setStatus(status);
            entity.setToDepartment(toDepartment);
            return entity;
        }

        /**
         * Constructs a new instance of {@link DepartmentPrivilegeTransfert}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param transfertDate Date
         * @param updateDate Timestamp
         * @param fromDepartment Department
         * @param status Status
         * @param toDepartment Department
         * @return newInstance DepartmentPrivilegeTransfert
         */
        public static DepartmentPrivilegeTransfert newInstance(Date transfertDate, Timestamp updateDate, Department fromDepartment, Status status, Department toDepartment)
        {
            final DepartmentPrivilegeTransfert entity = new DepartmentPrivilegeTransfertImpl();
            entity.setTransfertDate(transfertDate);
            entity.setUpdateDate(updateDate);
            entity.setFromDepartment(fromDepartment);
            entity.setStatus(status);
            entity.setToDepartment(toDepartment);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(DepartmentPrivilegeTransfert o)
    {
        int cmp = 0;
        if (this.getDepartmentPrivilegeTransfertPk() != null)
        {
            cmp = this.getDepartmentPrivilegeTransfertPk().compareTo(o.getDepartmentPrivilegeTransfertPk());
        }
            if (this.getTransfertDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTransfertDate().compareTo(o.getTransfertDate()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// DepartmentPrivilegeTransfert.java merge-point
}